module Box  where

import Foreign
import Foreign.C
import Foreign.C.String

data Box = Box ()

data BoxPtr = BoxPtr (ForeignPtr Box)

foreign import ccall f_newBox :: Int -> Int -> Int -> Int -> CString -> IO (Ptr Box)
foreign import ccall f_deleteBox :: (Ptr Box) -> IO ()

newBox :: Int -> Int -> Int -> Int -> String -> IO BoxPtr
newBox a b c d e = do
  thestring <- newCString e
  it <- f_newBox a b c d thestring
  fptr <- newForeignPtr it (f_deleteBox it)
  return (BoxPtr fptr)
