-- Note that this whole file could be generated automatically and is a lot of
-- repeated code (yuck!)
--
module Button(
  ButtonPtr,
  newButton, 
  button_memfun_callback,
  button_memfun_setLabel,
  button_memfun_getLabel,
  button_memfun_position,
  button_memfun_size,
  button_memfun_x,
  button_memfun_y,
  button_memfun_w,
  button_memfun_h,
  button_memfun_do_callback 
) where

import Foreign
import Foreign.C
import Foreign.C.String

data F_Widget = F_Widget ()
data F_Button = F_Button ()

data Void = Void ()

data ButtonPtr = ButtonPtr (ForeignPtr F_Button)

foreign import ccall f_newButton :: Int -> Int -> Int -> Int -> CString -> IO (Ptr F_Button)
foreign import ccall f_deleteButton :: (Ptr F_Button) -> IO ()

foreign import ccall "wrapper" mkCallback :: (Ptr F_Widget -> IO()) -> IO( FunPtr (Ptr F_Widget -> IO()) )
foreign import ccall f_Button_memfn_callback :: Ptr F_Button -> FunPtr (Ptr F_Widget -> IO ()) -> IO ()

foreign import ccall f_Button_memfn_setLabel :: Ptr F_Button -> CString -> IO ()
foreign import ccall f_Button_memfn_getLabel :: Ptr F_Button -> IO( CString )
foreign import ccall f_Button_memfn_position :: Ptr F_Button -> Int -> Int -> IO( )
foreign import ccall f_Button_memfn_size :: Ptr F_Button -> Int -> Int -> IO( )
foreign import ccall f_Button_memfn_x :: Ptr F_Button -> IO( Int )
foreign import ccall f_Button_memfn_y :: Ptr F_Button -> IO( Int )
foreign import ccall f_Button_memfn_w :: Ptr F_Button -> IO( Int )
foreign import ccall f_Button_memfn_h :: Ptr F_Button -> IO( Int )
foreign import ccall f_Button_memfn_do_callback :: Ptr F_Button -> IO( )

newButton :: Int -> Int -> Int -> Int -> String -> IO ButtonPtr
newButton a b c d e = do
  thestring <- newCString e
  it <- f_newButton a b c d thestring
  fptr <- newForeignPtr it (f_deleteButton it)
  return (ButtonPtr fptr)

button_memfun_callback :: ButtonPtr -> IO() -> IO()
button_memfun_callback a function = do
  let ButtonPtr  b = a
  let z = (\w -> function ) :: (Ptr F_Widget -> IO())
  funptr <- mkCallback z
  f_Button_memfn_callback (foreignPtrToPtr b) funptr
  touchForeignPtr b
  return ()

button_memfun_setLabel a s = do
   let ButtonPtr  b = a
   cstring <- newCString s
   f_Button_memfn_setLabel (foreignPtrToPtr b) cstring
   touchForeignPtr b
   return ()

button_memfun_getLabel a = do
   let ButtonPtr  b = a
   cstring <- f_Button_memfn_getLabel (foreignPtrToPtr b)
   touchForeignPtr b
   peekCString cstring

button_memfun_position a x y = do
   let ButtonPtr  b = a
   f_Button_memfn_position (foreignPtrToPtr b) x y
   touchForeignPtr b

button_memfun_size a x y = do
   let ButtonPtr  b = a
   f_Button_memfn_size (foreignPtrToPtr b) x y
   touchForeignPtr b

button_memfun_x a = do
   let ButtonPtr  b = a
   a <- f_Button_memfn_x (foreignPtrToPtr b)
   touchForeignPtr b
   return a

button_memfun_y a = do
   let ButtonPtr  b = a
   a <- f_Button_memfn_y (foreignPtrToPtr b)
   touchForeignPtr b
   return a

button_memfun_w a = do
   let ButtonPtr  b = a
   a <- f_Button_memfn_w (foreignPtrToPtr b)
   touchForeignPtr b
   return a

button_memfun_h a = do
   let ButtonPtr  b = a
   a <- f_Button_memfn_h (foreignPtrToPtr b)
   touchForeignPtr b
   return a

button_memfun_do_callback a = do
   let ButtonPtr  b = a
   f_Button_memfn_do_callback (foreignPtrToPtr b)
   touchForeignPtr b
