module Main where

import Fl
import Window
import Box
import Button

helloPressed :: ButtonPtr -> Bool -> IO()
helloPressed a True = do
    a `button_memfun_setLabel` "World"
    a `button_memfun_callback` (helloPressed a False)
helloPressed a False = do
    a `button_memfun_setLabel` "Hello"
    a `button_memfun_callback` (helloPressed a True)

main =
  do
    window <- newWindow 300 200
    box <- newBox 0 0 300 200 "Hello, World!"
    hello <- newButton 0 0 300 50 "Hello"
    hello `button_memfun_callback` (helloPressed hello True)
    exitB <- newButton 0 150 300 50 "exit"
    exitB `button_memfun_callback` (exit 1)
    window_memfun_end window
    window_memfun_show window
    fl_memfun_run
