module Main where

import Fl
import Window
import Box
import A_Button


helloPressed :: A_Button -> Bool -> IO()
helloPressed a True = 
  set a [ title =: "World", onPress =: (helloPressed a False) ]
helloPressed a False = 
  set a [ title =: "Hello", onPress =: (helloPressed a True) ]

main =
  do
    window <- newWindow 300 200
    box <- newBox 0 0 300 200 "Hello, World!"

    hello <- a_button [ title =: "Hello", position =: (0,0), size =: (300,50) ]
    set hello [ onPress =: (helloPressed hello True) ]

    exitB <- a_button [ title =: "exit", onPress =: (exit 1),
      position =: (0,150), size =: (300,50) ]

    window_memfun_end window
    window_memfun_show window
    fl_memfun_run
